#ifndef	INC_drv5565_h
#define	INC_drv5565_h
/**
 *	@file	drv5565.h
 *	@brief	
 *	$Date:: 2022-11-10 11:10:31 +0900#$
 *	$Revision: 8 $
 *	$Author: iitsuka $
 */
#include <stdbool.h>
#include <ellLib.h>
#include <dbScan.h>

typedef	void	*RM5565_t;

typedef	unsigned long long	rmoffset_t;

typedef	struct {
	ELLNODE link;
	IOSCANPVT scan_nint[4u];
	IOSCANPVT scan_baddata;
	IOSCANPVT scan_fifofull;
	IOSCANPVT scan_roguedet;
	IOSCANPVT scan_fifoafull;
	IOSCANPVT scan_syncloss;
	epicsUInt32 count_baddata;
	epicsUInt32 count_fifofull;
	epicsUInt32 count_roguedet;
	epicsUInt32 count_fifoafull;
	epicsUInt32 count_syncloss;
	int card;
} RM5565info_t;

#ifdef	__cplusplus
extern "C" {
#endif	/* __cplusplus */

/**	@cond		*/
extern	RM5565_t drvRM5565_getHandle(int card);
extern	inline RM5565info_t *drvRM5565_info(RM5565_t handle);
extern	inline bool drvRM5565_validOffset(RM5565_t handle, ptrdiff_t offset);
#if		defined(vxWorks)
extern	inline volatile void *drvRM5565_ptr(RM5565_t handle, ptrdiff_t offset);
#endif	/* defined(vxWorks) */
extern	int drvRM5565_readSID(RM5565_t handle, epicsUInt8 intId, epicsUInt8 *pSID);
extern	int drvRM5565_readISD(RM5565_t handle, epicsUInt8 intId, epicsUInt32 *pISD);
extern	int drvRM5565_txInt(RM5565_t handle, epicsUInt16 node, epicsUInt8 intId, epicsUInt32 data);
extern	int drvRM5565_clearOwnData(RM5565_t handle);
extern	int drvRM5565_waitOwnData(RM5565_t handle, epicsFloat64 tmout);
extern	int drvRM5565_readLED(RM5565_t handle);
extern	int drvRM5565_writeLED(RM5565_t handle, int cond);
#if		defined(linux)
extern	int drvRM5565_dmaThreshold(RM5565_t handle, epicsUInt32 threshold);
extern	int drvRM5565_dmaByteSwap(RM5565_t handle, bool fswap);
#endif	/* defined(linux) */
extern	int drvRM5565_read(RM5565_t handle, epicsUInt32 offset, void *pbuff, epicsUInt32 bytes);
extern	int drvRM5565_read32(RM5565_t handle, epicsUInt32 offset, void *pData);
extern	int drvRM5565_read16(RM5565_t handle, epicsUInt32 offset, void *pData);
extern	int drvRM5565_read8(RM5565_t handle, epicsUInt32 offset, void *pData);
extern	int drvRM5565_write(RM5565_t handle, epicsUInt32 offset, void *pbuff, epicsUInt32 bytes);
extern	int drvRM5565_write32(RM5565_t handle, epicsUInt32 offset, epicsUInt32 data);
extern	int drvRM5565_write16(RM5565_t handle, epicsUInt32 offset, epicsUInt16 data);
extern	int drvRM5565_write8(RM5565_t handle, epicsUInt32 offset, epicsUInt8 data);
#if		defined(linux)
extern	int drvRM5565_map(RM5565_t handle, volatile void **p, rmoffset_t offset, epicsUInt32 size);
extern	int drvRM5565_mapDMA(RM5565_t handle, volatile void **p, rmoffset_t offset, epicsUInt32 size);
extern	int drvRM5565_unmap(RM5565_t handle, volatile void **p, epicsUInt32 size);
#endif	/* defined(linux) */
/**	@endcond	*/

#ifdef	__cplusplus
}
#endif	/* __cplusplus */

#endif	/* INC_drv5565 */

